﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using VSMSearchSample.Models;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace VSMSearchSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class CategoryPage : Page
    {
        public CategoryPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (e.Parameter is NavItem)
            {
                var navItem = (NavItem)e.Parameter;

                if (navItem.Id == "category")
                {
                    itemGridView.ItemsSource = App.ViewModel.Categories;
                    itemGridView.ItemTemplate = (DataTemplate)App.Current.Resources["CategoryGroupTemplate"];
                }
                else
                {
                    itemGridView.ItemsSource = App.ViewModel.Presenters;
                    itemGridView.ItemTemplate = (DataTemplate)App.Current.Resources["PresenterGroupTemplate"];
                }
                pageTitle.Text = navItem.Title;
            }
        }

        private void ItemView_ItemClick(object sender, ItemClickEventArgs e)
        {
           
            Frame.Navigate(typeof(SessionsPage), e.ClickedItem);
        }

        private void GoBack(object sender, RoutedEventArgs e)
        {
            if (this.Frame != null && this.Frame.CanGoBack) this.Frame.GoBack();
        }
    }
}
