﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using VSMSearchSample.Models;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace VSMSearchSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class SessionsPage : Page
    {
        public SessionsPage()
        {
            this.InitializeComponent();
            Loaded += SessionsPage_Loaded;
        }

        void SessionsPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (itemGridView.SelectedItem != null && itemGridView.SelectedItem is Session)
            {
                ShowSession(itemGridView.SelectedItem as Session);
            }

        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if(e.Parameter is Category) {
                var cat = e.Parameter as Category;
                itemGridView.ItemsSource = cat.Sessions;
                pageTitle.Text = cat.Name;
                parentTitle.Text = "Categories";
            } else if (e.Parameter is Presenter) {
                var pre = e.Parameter as Presenter;
                itemGridView.ItemsSource = pre.Sessions;
                pageTitle.Text = pre.Name;
                parentTitle.Text = "Presenters";
            }
            else if (e.Parameter is Session)
            {
                var sess = e.Parameter as Session;
                var cat = sess.Categories[0];
                itemGridView.ItemsSource = cat.Sessions;
                pageTitle.Text = cat.Name;
                parentTitle.Text = "Categories";
                itemGridView.SelectedItem = sess;
            }
        }

        private void ShowSession(Session session)
        {
            if (!popSession.IsOpen)
            {
                popSession.HorizontalOffset = ActualWidth - 646;
                gridDetails.Height = ActualHeight;
                gridDetails.Width = 646;
                popSession.IsOpen = true;
            }
            gridDetails.DataContext = session;

        }

        private void ItemView_ItemClick(object sender, ItemClickEventArgs e)
        {
            ShowSession(e.ClickedItem as Session);
        }

        private void GoBack(object sender, RoutedEventArgs e)
        {
            if (this.Frame != null && this.Frame.CanGoBack) this.Frame.GoBack();
        }

        private void Close(object sender, RoutedEventArgs e)
        {
            popSession.IsOpen = false;
        }
    }
}
